function result=NRL(embed,lag,series)   
    N_series = numel(series);
    M = N_series - (embed - 1) * lag;
    vectors=reconstruction(series,M,embed,lag);  
    dist = distance(vectors,embed,M);
    min=0;
    max=0;
    for j=1:M
       min = min + find_closest(dist,j,M);
       max = max + find_furthest(dist,j,M);
    end
    result(1)=min/max;
    result(2)=min;
    result(3)=max;
end
    
function vectors = reconstruction(series,M,embed,lag)
    vectors=zeros(M,embed);
    for i=1:M
        for j=1:embed
            vectors(i, j) = series(i + (j - 1) * lag);
        end
    end
end

function dist = distance(vectors,embed,M)
    dist=zeros(M,M);
    for i=1:M
       dist(i,i)=0; 
    end
    for i=1:(M-1)
       for j=(i+1):M
           dist(i,j)=0; 
           for k=1:embed
                dist(i,j) = dist(i,j) + (vectors(i, k) - vectors(j, k))^2;
           end
           dist(i,j) = sqrt(dist(i,j));
           dist(j,i)=dist(i,j);
       end
    end
end

function min=find_closest(dist,j,M)
    
    min = 10000000;       
    for k=1:M    
        if k~=j   
           if dist(j,k) < min 
               min = dist(j,k);
           end
        end
    end       
end

function max=find_furthest(dist,j,M)   
    
    max = 0.00000001;
    for k = 1 : M    
           if dist(j,k) > max 
               max = dist(j,k);
           end
    end       
end 
